unit FColorSet;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, UTuxBase, QExtCtrls, QButtons;

type
  TColorSetForm = class(TForm)
    Label1: TLabel;
    OutlinePanel: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    ColDialog: TColorDialog;
    OKButton: TBitBtn;
    CancelButton: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure OutlinePanelClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  ColorSetForm: TColorSetForm;

implementation

{$R *.xfm}

procedure TColorSetForm.FormShow(Sender: TObject);
begin
  OutlinePanel.Color := iiOutlinecol;
end;

procedure TColorSetForm.OutlinePanelClick(Sender: TObject);
begin
  ColDialog.color := OutlinePanel.color;
  if ColDialog.Execute then begin
     OutlinePanel.Color := ColDialog.Color;
  end;
end;

procedure TColorSetForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TColorSetForm.OKButtonClick(Sender: TObject);
begin
  iiOutlineCol := OutlinePanel.Color;
  ModalResult := mrOK;
end;

end.
