unit FSaveQuery;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QButtons;

type
  TSaveQueryForm = class(TForm)
    Label1: TLabel;
    YesButton: TBitBtn;
    NoButton: TBitBtn;
    CancelButton: TBitBtn;
    procedure YesButtonClick(Sender: TObject);
    procedure NoButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  SaveQueryForm: TSaveQueryForm;

implementation

{$R *.xfm}

procedure TSaveQueryForm.YesButtonClick(Sender: TObject);
begin
  ModalResult := mrYes;
end;

procedure TSaveQueryForm.NoButtonClick(Sender: TObject);
begin
  ModalResult := mrNo;
end;

procedure TSaveQueryForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
