unit FTuxedit;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls, QMenus, QButtons, FCourseDir,
  UTuxbase, UStandard, UFiles, FCourseParams, QGrey, QElevBrush,
  QTerrPalette, UMaps, QTerrBrush, UObjects, USpecial;


type
  TMain = class(TForm)
    ButtonPanel: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    ClientPanel: TPanel;
    ClientScroll: TScrollBox;
    Panel8: TPanel;
    ClientRegister: TPageControl;
    course: TTabSheet;
    elevation: TTabSheet;
    terrain: TTabSheet;
    objects: TTabSheet;
    MainMenu1: TMainMenu;
    mmFile: TMenuItem;
    OpenFileButton: TSpeedButton;
    mmObjects: TMenuItem;
    mmSettings: TMenuItem;
    mmSetPath: TMenuItem;
    OpenDialog: TOpenDialog;
    mmHelp: TMenuItem;
    mmOpen: TMenuItem;
    mmSave: TMenuItem;
    mmClose: TMenuItem;
    Client: TPaintBox;
    SaveFileButton: TSpeedButton;
    CourseDirPanel: TPanel;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    CourseButton: TSpeedButton;
    TargetsButton: TSpeedButton;
    ElevationButton: TSpeedButton;
    TerrainButton: TSpeedButton;
    ObjectsButton: TSpeedButton;
    InternalButton: TSpeedButton;
    targets: TTabSheet;
    internal: TTabSheet;
    Label5: TLabel;
    InfoPanel: TPanel;
    Label8: TLabel;
    CourseTCLPanel: TPanel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    coLEdit: TPanel;
    coWEdit: TPanel;
    coPlayLEdit: TPanel;
    coPlayWEdit: TPanel;
    coAngleEdit: TPanel;
    coScaleEdit: TPanel;
    coStartEdit: TPanel;
    CourseEditButton: TBitBtn;
    Label13: TLabel;
    Label28: TLabel;
    iiTrackPanel: TPanel;
    Label10: TLabel;
    iiHeightEdit: TPanel;
    Label11: TLabel;
    iiWidthEdit: TPanel;
    ScaleButt1: TSpeedButton;
    ScaleButt2: TSpeedButton;
    ScaleButt3: TSpeedButton;
    ScaleButt4: TSpeedButton;
    ScaleButt5: TSpeedButton;
    Panel9: TPanel;
    BackPanel: TPanel;
    ForePanel: TPanel;
    ElevToolPanel: TPanel;
    Panel7: TPanel;
    ElevBrush: TElevBrush;
    BrushButt: TSpeedButton;
    DarkButt: TSpeedButton;
    BlurButt: TSpeedButton;
    PipetteButt: TSpeedButton;
    MaskButt: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    TerrColPanel: TPanel;
    TerrBrush: TTerrBrush;
    Greyscale: TGreyscale;
    UndoButton: TSpeedButton;
    mmDeleteAllObjects: TMenuItem;
    mmDeleteAllBound: TMenuItem;
    mmDeleteAllHerr: TMenuItem;
    mmDeleteAllFlags: TMenuItem;
    ORegister: TPageControl;
    oselect: TTabSheet;
    oedit: TTabSheet;
    OEditButton: TSpeedButton;
    OAddButton: TSpeedButton;
    OMultiButton: TSpeedButton;
    ODelButton: TSpeedButton;
    ODelButton2: TSpeedButton;
    ObjectRegister: TPageControl;
    common: TTabSheet;
    trees: TTabSheet;
    rocks: TTabSheet;
    houses: TTabSheet;
    bridges: TTabSheet;
    misc: TTabSheet;
    ObjEditPanel: TPanel;
    ObjDelButt: TSpeedButton;
    EditCloseButton: TSpeedButton;
    MarkObjPanel: TPanel;
    MovePanel: TPanel;
    MoveUpButton: TSpeedButton;
    MoveRightButton: TSpeedButton;
    MoveLeftButton: TSpeedButton;
    MoveDownButton: TSpeedButton;
    Label53: TLabel;
    MoveStep: TTrackBar;
    Label54: TLabel;
    Panel16: TPanel;
    YDiffPanel: TPanel;
    Label45: TLabel;
    YDiffBar: TTrackBar;
    ZDiffPanel: TPanel;
    XDiffPanel: TPanel;
    XDiffBar: TTrackBar;
    RotationPanel: TPanel;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Label59: TLabel;
    XRotPanel: TPanel;
    YRotPanel: TPanel;
    YRotBar: TTrackBar;
    ZRotBar: TTrackBar;
    ZRotPanel: TPanel;
    AngleCheck: TCheckBox;
    XRotBar: TTrackBar;
    ScalePanel: TPanel;
    Image1: TImage;
    Image5: TImage;
    Image6: TImage;
    YScaleBar: TTrackBar;
    YScalePanel: TPanel;
    ZScalePanel: TPanel;
    ZScaleBar: TTrackBar;
    XScalePanel: TPanel;
    XScaleBar: TTrackBar;
    Label7: TLabel;
    Panel19: TPanel;
    ZDiffBar: TTrackBar;
    ShadowCheck: TCheckBox;
    ODispPanel: TPanel;
    ObjBrightButt1: TSpeedButton;
    ObjBrightButt2: TSpeedButton;
    ObjBrightButt3: TSpeedButton;
    ObjBrightButt4: TSpeedButton;
    ObjBrightButt5: TSpeedButton;
    rdmsPanel: TPanel;
    rdmrPanel: TPanel;
    Label6: TLabel;
    Label9: TLabel;
    MinSizeBar: TTrackBar;
    MaxSizeBar: TTrackBar;
    Label12: TLabel;
    MinRotBar: TTrackBar;
    Label22: TLabel;
    MaxRotBar: TTrackBar;
    MinSizePanel: TPanel;
    MaxSizePanel: TPanel;
    MinRotPanel: TPanel;
    MaxRotPanel: TPanel;
    CommonList: TListBox;
    TreesList: TListBox;
    RocksList: TListBox;
    HousesList: TListBox;
    BridgesList: TListBox;
    MiscList: TListBox;
    MinWidthBar: TTrackBar;
    MaxWidthBar: TTrackBar;
    MinWidthPanel: TPanel;
    MaxWidthPanel: TPanel;
    widthlabel: TLabel;
    Label25: TLabel;
    SpeedButton7: TSpeedButton;
    Panel10: TPanel;
    CommonButton: TSpeedButton;
    HousesButton: TSpeedButton;
    TreesButton: TSpeedButton;
    BridgesButton: TSpeedButton;
    RocksButton: TSpeedButton;
    MiscButton: TSpeedButton;
    Label23: TLabel;
    Label24: TLabel;
    TerrPanel: TPanel;
    BlurPanel: TPanel;
    BlurBar: TTrackBar;
    BlurDisp: TPanel;
    BrightPanel: TPanel;
    BrightBar: TTrackBar;
    BrightDisp: TPanel;
    Panel11: TPanel;
    TerrPalette: TTerrPalette;
    MixBar: TTrackBar;
    Label4: TLabel;
    MaskPanel: TPanel;
    SpecialButton1: TSpeedButton;
    SpecialButton3: TSpeedButton;
    SpecialButton2: TSpeedButton;
    Label29: TLabel;
    MaskPaintButton: TSpeedButton;
    MaskUnpaintButton: TSpeedButton;
    MaskClearButton: TSpeedButton;
    SoftBrushCover: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    ObjVisButton: TSpeedButton;
    ObjUnvisibButton: TSpeedButton;
    ObjVisButton2: TSpeedButton;
    ObjUnvisButton2: TSpeedButton;
    script: TTabSheet;
    ScriptButton: TSpeedButton;
    ScriptList: TListBox;
    Button1: TButton;
    Panel1: TPanel;
    BrushPaint: TPaintBox;
    BitBtn3: TBitBtn;
    Label26: TLabel;
    Label27: TLabel;
    Label31: TLabel;
    StartImage: TImage;
    SprayPanel: TPanel;
    MinSprayBar: TTrackBar;
    MaxSprayBar: TTrackBar;
    Label30: TLabel;
    Label32: TLabel;
    VallBar: TTrackBar;
    MountBar: TTrackBar;
    Label33: TLabel;
    Label34: TLabel;
    ButtonCoverPanel2: TPanel;
    ButtonCoverPanel1: TPanel;
    Label35: TLabel;
    Label36: TLabel;
    CourseLabel: TLabel;
    MinSprayDisp: TPanel;
    MaxSprayDisp: TPanel;
    VallDisp: TPanel;
    MountDisp: TPanel;
    mmAbout: TMenuItem;
    mmElevation: TMenuItem;
    mmTerrain: TMenuItem;
    Randomlandscape1: TMenuItem;
    N1: TMenuItem;
    mmElevClear: TMenuItem;
    WithoutOutlineButton: TSpeedButton;
    OutlineButton: TSpeedButton;
    BasementBar: TTrackBar;
    BasementDisp: TPanel;
    iiCupPanel: TPanel;
    Panel14: TPanel;
    CloseButton: TSpeedButton;
    N2: TMenuItem;
    Quit1: TMenuItem;
    mmSetColors: TMenuItem;
    BitBtn2: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mmSetPathClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mmOpenClick(Sender: TObject);
    procedure OpenFileButtonClick(Sender: TObject);
    procedure ClientPaint(Sender: TObject);
    procedure CourseButtonClick(Sender: TObject);
    procedure ElevationButtonClick(Sender: TObject);
    procedure TerrainButtonClick(Sender: TObject);
    procedure ObjectsButtonClick(Sender: TObject);
    procedure TargetsButtonClick(Sender: TObject);
    procedure InternalButtonClick(Sender: TObject);
    procedure CourseEditButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure ScaleButt1Click(Sender: TObject);
    procedure ScaleButt2Click(Sender: TObject);
    procedure ScaleButt3Click(Sender: TObject);
    procedure ScaleButt4Click(Sender: TObject);
    procedure ScaleButt5Click(Sender: TObject);
    procedure ObjBrightButt1Click(Sender: TObject);
    procedure ObjBrightButt2Click(Sender: TObject);
    procedure ObjBrightButt3Click(Sender: TObject);
    procedure ObjBrightButt4Click(Sender: TObject);
    procedure ObjBrightButt5Click(Sender: TObject);
    procedure GreyscaleSelect(nr, grey: Integer; color: TColor);
    procedure BrushButtClick(Sender: TObject);
    procedure DarkButtClick(Sender: TObject);
    procedure BlurButtClick(Sender: TObject);
    procedure PipetteButtClick(Sender: TObject);
    procedure MaskButtClick(Sender: TObject);
    procedure mmCloseClick(Sender: TObject);
    procedure ElevBrushSelect(nr: Integer);
    procedure ClientMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ClientMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ClientMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TerrPaletteSelect(Color: TColor; TerrName: String);
    procedure TerrBrushSelect(nr: Integer);
    procedure SaveFileButtonClick(Sender: TObject);
    procedure mmSaveClick(Sender: TObject);
    procedure OEditButtonClick(Sender: TObject);
    procedure OAddButtonClick(Sender: TObject);
    procedure ODelButtonClick(Sender: TObject);
    procedure OMultiButtonClick(Sender: TObject);
    procedure XDiffBarChange(Sender: TObject);
    procedure YDiffBarChange(Sender: TObject);
    procedure ZDiffBarChange(Sender: TObject);
    procedure XScaleBarChange(Sender: TObject);
    procedure YScaleBarChange(Sender: TObject);
    procedure ZScaleBarChange(Sender: TObject);
    procedure XRotBarChange(Sender: TObject);
    procedure YRotBarChange(Sender: TObject);
    procedure ZRotBarChange(Sender: TObject);
    procedure EditCloseButtonClick(Sender: TObject);
    procedure ObjDelButtClick(Sender: TObject);
    procedure mmDeleteAllObjectsClick(Sender: TObject);
    procedure mmDeleteAllBoundClick(Sender: TObject);
    procedure mmDeleteAllHerrClick(Sender: TObject);
    procedure mmDeleteAllFlagsClick(Sender: TObject);
    procedure MoveUpButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MoveLeftButtonMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MoveRightButtonMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MoveDownButtonMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ODelButton2Click(Sender: TObject);
    procedure ClientScrollMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AngleCheckClick(Sender: TObject);
    procedure CommonListClick(Sender: TObject);
    procedure ObjectRegisterChange(Sender: TObject);
    procedure MinSizeBarChange(Sender: TObject);
    procedure MaxSizeBarChange(Sender: TObject);
    procedure MinRotBarChange(Sender: TObject);
    procedure MaxRotBarChange(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure CommonButtonClick(Sender: TObject);
    procedure TreesButtonClick(Sender: TObject);
    procedure RocksButtonClick(Sender: TObject);
    procedure HousesButtonClick(Sender: TObject);
    procedure BridgesButtonClick(Sender: TObject);
    procedure MiscButtonClick(Sender: TObject);
    procedure ClientRegisterChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure ORegisterChanging(Sender: TObject; var AllowChange: Boolean);
    procedure ObjectRegisterChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure UndoButtonClick(Sender: TObject);
    procedure ObjVisButtonClick(Sender: TObject);
    procedure ObjUnvisibButtonClick(Sender: TObject);
    procedure BlurBarChange(Sender: TObject);
    procedure BrightBarChange(Sender: TObject);
    procedure MixBarChange(Sender: TObject);
    procedure MaskPaintButtonClick(Sender: TObject);
    procedure MaskUnpaintButtonClick(Sender: TObject);
    procedure MaskClearButtonClick(Sender: TObject);
    procedure SpecialButton1Click(Sender: TObject);
    procedure SpecialButton2Click(Sender: TObject);
    procedure SpecialButton3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ForePanelClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ObjVisButton2Click(Sender: TObject);
    procedure ObjUnvisButton2Click(Sender: TObject);
    procedure ScriptButtonClick(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure MinSprayBarChange(Sender: TObject);
    procedure MaxSprayBarChange(Sender: TObject);
    procedure VallBarChange(Sender: TObject);
    procedure MountBarChange(Sender: TObject);
    procedure BasementBarChange(Sender: TObject);
    procedure mmAboutClick(Sender: TObject);
    procedure WithoutOutlineButtonClick(Sender: TObject);
    procedure OutlineButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Quit1Click(Sender: TObject);
    procedure Randomlandscape1Click(Sender: TObject);
    procedure mmElevClearClick(Sender: TObject);
    procedure mmSetColorsClick(Sender: TObject);
  private
    ButtonDown: boolean;
    OldX, OldY: integer;
    StartX, StartY: integer;
    MoveX, MoveY: integer;
    MinX, MinY: integer;
    MaxX, MaxY: integer;

    procedure SetCourseDir;
    procedure PaintPixel (c: TCanvas; x, y, scale: integer; col: TColor);
    procedure ShowElevBrush (c: TCanvas; scale: integer);
    procedure RandomExecute;
    procedure MaskExecute (nr: integer);
    procedure ClearMask;
    procedure ClearMaskArr;
    procedure SetMaskMode (mask: integer);
    procedure Undo;
    function  InsertObject  (x, y, typ: integer; var isnew: boolean): integer;
    procedure ShowRandomSize;
    procedure ShowRandomRot;
    procedure ShowObjDef;   // shows default controls of object
    procedure PaintFinishLine;
    procedure MoveObject (dx,dy: integer);
    procedure DeleteObject (x, y, size: integer);
    procedure ReadEditParams;
    procedure PaintMark;
    procedure OpenEditState (idx: integer);
    procedure CloseEditState;
    procedure SetMark (idx: integer);
    procedure ResetMark;
    function  ObjFind (x,y:integer): integer;
    function  ObjFindNear (x,y: integer): integer;
    function  GetObjTyp: integer; // liest objnr aus den Seiten aus
    procedure ReadObjects;
    procedure SetTerrBrush (brush: integer);
    procedure SetElevBrush (brush: integer);
    procedure ResetElevTool;
    procedure SetElevTool (tool: integer);
    procedure SetObjectTool (tool: integer);
    procedure SetObjBright (bright: integer);
    procedure SetMix (mix: integer);
    procedure SetScale (scale: integer);
    procedure SetEditMode (mode: integer);
    procedure Init;
    procedure OpenCourse;
    procedure CloseCourse;
    procedure SaveCourse;
    procedure PaintClient;
    procedure PaintObject (idx: integer);
    procedure PaintObjectsRect (r: TRect);
    procedure PaintObjects;
    procedure RegenerateObjectRect (x,y: integer);

    procedure ReadCourseParams;
  public
  end;

var
  Main: TMain;

implementation

uses FAbout, FSaveQuery, FColorSet;

{$R *.xfm}
{$I I_Buttons.pas}

{--------------------------------------------------------------}
{                       private                                }
{--------------------------------------------------------------}

(*procedure TMain.PaintMountain;
var bpar: TBrushPar;
    i, ebrush: integer;
    xpos, ypos: integer;
begin
  bpar := mpBrushPar;
  ebrush := mpElevBrush;
  xpos := x + XRandom (-10, 10);
  ypos := y + XRandom (-10, 10);

  SetElevBrush (13);
  for i := 1 to 20 do PaintBrightSpot (xpos, ypos);
  xpos := xpos + XRandom (-5, +5);
  ypos := ypos + XRandom (-5, +5);
  SetElevBrush (10);
  for i := 1 to 20 do PaintBrightSpot (xpos, ypos);
  xpos := xpos + XRandom (-3, +3);
  ypos := ypos + XRandom (-3, +3);
  SetElevBrush (9);
  for i := 1 to 10 do PaintBrightSpot (xpos, ypos);

  GenerateBrush (bpar.size, bpar.intens, bpar.soft);
  mpElevBrush := ebrush;
end;*)

procedure TMain.mmSetPathClick; {----------------------------}
begin
  SetCourseDir;
end;

procedure TMain.SetCourseDir; {--------------------------------}
begin
  if iiCourseDirOK and DirectoryExists (iiCourseDir) then
    CourseDirForm.DirTree.directory := iiCourseDir;
  if CourseDirForm.ShowModal = mrOK then begin
    iiCourseDir := CourseDirForm.DirTree.Directory;
    if iiCourseDir[length(iiCourseDir)] = SEP then Delete (iiCourseDir, length(iiCourseDir), 1);
    B_CheckStructure (CourseDirPanel);
  end;
end;

procedure TMain.PaintPixel; {-------------------------------}
var xx, yy:integer;
begin
  if scale = 1 then begin
    c.Pixels[x,y] := col;
  end else begin
    c.brush.color := col;
    c.pen.color := col;
    xx := x * scale;
    yy := y * scale;
    c.rectangle (xx, yy, xx + scale, yy + scale);
  end;
end;

procedure TMain.ShowElevBrush; {--------------------------------}
var i,j: integer;
    col: integer;
begin
  c.brush.color := clWhite;
  c.rectangle(-1, -1, 1000, 1000);
  for i := 0 to mpBrushPar.size-1 do for j := 0 to mpBrushPar.size-1 do begin
    col := round (255 - ElevBrushArr[i,j] * 255 / 100);
    PaintPixel (c, i, j, scale, cCol (col, col, col));
  end;
end;

procedure TMain.RandomExecute; {-------------------------------}
var ss: String;
    bpar: TBrushPar;
    egrey, ebrush: integer;
begin
  if not iiOpen then exit;
  if EditMode <> emElev then exit;
  // store current params
  bpar := mpBrushPar;
  egrey := mpElevGrey;
  ebrush := mpElevBrush;

  iiElevChanged := true;
  StoreElev;

  ss := '[act]fill[val]50';
  RandomEx (ss);
  EArr_MMap;
  PaintClient;
  ss := '[act]spot[arcnt]1[cnt-]100[cnt+]200[size-]20[size+]41[val-]0[val+]200';
  RandomEx (ss);
  ss := '[act]spot[arcnt]1[cnt-]20[cnt+]100[size-]10[size+]41[val-]0[val+]250';
  RandomEx (ss);
(*
  ss := '[act]spot[cnt]200[size-]10[size+]20[val-]120[val+]255[x+]15[press]80';
  RandomEx (ss);
  ss := '[act]line[cnt]100[size-]10[size+]10[val-]100[val+]255[press]40[xdist-]10[xdist+]100[ydist-]20[ydist+]200[x+]10';
  RandomEx (ss);
  ss:='[act]2[count]15[size]41[press]60[len]80[range]15[min]100[max]250';
  RandomEx (ss);
  ss:='[act]2[count]100[size]21[press]40[len]12[range]5[min]120[max]255';
  RandomEx (ss);
  ss:='[act]2[count]100[size]13[press]40[len]8[range]3[min]150[max]255';
  RandomEx (ss);
  ss:='[act]2[count]100[size]21[press]40[len]25[range]3[min]0[max]80';
  RandomEx (ss);*)

  // restore current params
  GenerateBrush (bpar.size, bpar.intens, bpar.soft);
  mpElevGrey := egrey;
  mpElevBrush := ebrush;

  EArr_MMap;
  PaintClient;
end;

procedure TMain.MaskExecute; {----------------------------------}
begin
  StoreElev;
  MaskEx (iiWidth, iiHeight, nr);
  iiElevChanged := true;
  EArr_MMap;
  PaintClient;
end;

procedure TMain.ClearMask; {--------------------------------}
begin
  if mpElevTool <> etMask then exit;
  ClearMaskArr;
  EArr_MMap;
  PaintClient;
end;

procedure TMain.ClearMaskArr; {-----------------------------}
var i, j: integer;
begin
  for i := 0 to MaxHeight do for j := 0 to MaxWidth do MaskArr[i,j] := 0;
end;

procedure TMain.SetMaskMode; {------------------------------}
begin
  if not iiOpen then exit;
  if mpMaskMode = mask then exit;
  mpMaskMode := mask;
  EArr_MMap;
  PaintClient;
end;

procedure TMain.Undo; {-------------------------------------}
begin
  if EditMode = emElev then begin
    RestoreElev;
    EArr_MMap;
    PaintClient;
  end else if EditMode = emTerr then begin
    RestoreTerr;
    TMap_MMap;
    PaintClient;
  end;
end;

function TMain.InsertObject; {---------------------------------}
var ss, idxstr: String;
    idx: Integer;
    xwidth, ywidth, scale, rot: double;
begin
  if (x < 0 ) or (x >= iiWidth) or (y < 0) or (y >= iiHeight) then begin
    Result := -1;   // error 1: not in bitmap range
  end else begin
    ss := O_GetObjStr (typ);
    if ss = '' then begin
      Result:= -2;  // error 2: object type not in list
    end else begin
      ss := ss + '[x]' + inttostr(x) + '[y]' + inttostr(y);

      if pos ('[r360]', ss) > 0 then SetParsInt (ss, 'rz', XRandom (-170, 179));
      if rdmsPanel.visible then begin
        scale := XRandom (MinSizeBar.position, MaxSizeBar.position) / 10;
        xwidth := XRandom (MinWidthBar.Position, MaxWidthBar.position) / 10 * scale;
        ywidth := XRandom (MinWidthBar.Position, MaxWidthBar.position) / 10 * scale;
//        edit1.text := floatToStr(xwidth) + '   ' + floattostr (ywidth);
        SetParsFloat (ss, 'sx', xwidth, 2);
        SetParsFloat (ss, 'sy', ywidth, 2);
        SetParsFloat (ss, 'sz', scale, 2);
      end;
      if rdmrPanel.visible then begin
        rot := XRandom (MinRotBar.Position, MaxRotBar.Position);
        SetParsFloat (ss, 'rx', rot, 2);
      end;

      idxstr := IntToStr(x) + '-' + IntToStr(y);  // for OIdx
      idx := ParsInt (OIdx, idxstr, -1);
      if idx < 0 then begin // new object at this point
        OArr.Add (ss);
        idx := OArr.Count-1;
        SetParsInt (OIdx, idxstr, idx);
        isnew := true;
      end else if idx < OArr.Count then begin // overwrite existing object at this point
        OArr[idx] := ss;
        SetParsInt (OIdx, idxstr, idx);
        isnew := false;
      end else idx := -3;  // error 3: index out of range
      Result := idx;
    end;
  end;
end;

procedure TMain.ShowRandomSize;
begin
  MinSizePanel.caption := Float_Str (MinSizeBar.position / 10, 1);
  MaxSizePanel.caption := Float_Str (MaxSizeBar.position / 10, 1);
  MinWidthPanel.caption := Float_Str (MinWidthBar.Position / 10, 1);
  MaxWidthPanel.caption := Float_Str (MaxWidthBar.Position / 10, 1);
end;

procedure TMain.ShowRandomRot;
begin
  MinRotPanel.caption := Float_Str (MinRotBar.position, 0);
  MaxRotPanel.caption := Float_Str (MaxRotBar.position, 0);
end;

procedure TMain.ShowObjDef; {----------------------------------}
var ss,sss: String;
begin
  ss := O_GetObjStr (GetObjTyp);
  if pos ('[rdms]', ss) > 0 then begin
    rdmsPanel.visible := true;
    MinSizeBar.position := 8;
    MaxSizeBar.position := 12;
    MinWidthBar.Position := 8;
    MaxWidthBar.Position := 12;
  end else begin
    rdmsPanel.visible := false;
  end;
  if pos ('[rdmr]', ss) > 0 then begin
    rdmrPanel.visible := true;
    MinRotBar.position := -5;
    MaxRotBar.position := 5;
  end else begin
    rdmrPanel.visible := false;
  end;

end;

procedure TMain.PaintFinishLine; {-----------------------------}
var i, y: integer;
begin
  if iiPlaylength<iiCourseLength then begin
    y:=trunc(iiHeight * iiPlayLength / iiCourseLength) -1;
    MMap.Canvas.pen.color:=clBlack;
    for i:=0 to mpScale-1 do begin
      MMap.Canvas.MoveTo(0, y * mpScale + i);
      MMap.Canvas.LineTo(iiWidth * mpScale, y * mpScale + i);
    end;
  end;
end;

procedure TMain.MoveObject; {----------------------------------}
var ss: String;
    oldidx, idx, typ: integer;
    x, y, z, newx, newy, newz: integer;
begin
  if (FMarkNum < 0) or (FMarkNum >= OArr.Count) then exit;
  idx := FMarkNum;
  ResetMark;
  ss := OArr[idx];
  x := ParsInt(ss, 'x', 0);
  y := ParsInt(ss, 'y', 0);
  z := ParsInt(ss, 'z', 0);
  newx := x + dx;
  if newx < 0 then newx := 0;
  if newx > iiWidth-1 then newx := iiWidth-1;
  newy := y + dy;
  if newy < 0 then newy := 0;
  if newy > iiHeight-1 then newy := iiHeight-1;
  newz := cRed (EMap.canvas.pixels [newx, newy]);
  oldidx := ParsInt (OIdx, IntToStr (newx) + '-' + IntToStr (newy), -1);
  if (oldidx >= 0) and (oldidx < OArr.Count) then OArr [oldidx] := 'Del';
  SetParsInt (OIdx, IntToStr(x) + '-' + IntToStr(y), -1);
  SetParsInt (OIdx, IntToStr(newx) + '-' + IntToStr(newy), idx);
  SetParsInt (ss, 'x', newx);
  SetParsInt (ss, 'y', newy);
  SetParsInt (ss, 'z', newz);
  OArr[idx] := ss;
  RegenerateObjectRect (x, y);
  SetMark (idx);
end;

procedure TMain.DeleteObject; {-----------------------------}
var i, j, del: integer;
    area: boolean;
// O_DeleteObject Rckgabe: 0 = Fehler, 1 = Punktobjekt, 2 = Outlineobjekt
begin
  area := false;
  if size = 1 then begin
    del := O_DeleteObject (x, y);
    case del of
     1: O_UnpaintOPixel (x, y);
     2: area := true;
    end;
  end else if size = 3 then begin
    for i := -1 to 1 do for j := -1 to 1 do begin
      del := O_DeleteObject (x+i, y+j);
      case del of
       1: O_UnpaintOPixel (x+i, y+j);
       2: area := true;
      end;
    end;
  end else begin
    for i := -5 to 5 do for j := -5 to 5 do begin
      del := O_DeleteObject (x+i, y+j);
      case del of
       1: O_UnpaintOPixel (x+i, y+j);
       2: area := true;
      end;
    end;
  end;
  if area then RegenerateObjectRect (x, y) else PaintClient;
end;

procedure TMain.ReadEditParams; {------------------------------}
var d, val, rest: double;
    vv, ca: integer;
begin
  MoveStep.Position := 1;
  XDiffBar.position := round (ParsFloat (FMarkStr, 'dx', 0) * 10);
  XDiffBarChange (self);
  YDiffBar.position := round (ParsFloat (FMarkStr, 'dy', 0) * 10);
  YDiffBarChange (self);
  MarkObjPanel.caption:=ParsStr(FMarkStr,'trivname')+'  '
    + ParsStr (FMArkStr, 'shape');

  val := ParsFloat (FMarkStr, 'dz', 0);
  ZDiffBar.position := round( 200 - 10 * val);
  ZDiffBarChange (self);

  if ParsInt (FMarkStr, 'scale', 0) > 0 then begin
//    eq := ParsInt (FMarkStr, 'eq', 0);
//    EqualCheck.Checked := (eq > 0);

    ZScaleBar.Position := ZScaleBar.max + 1
      - round (ParsFloat (FMarkStr, 'sz', 1) * 10);
    ZScaleBarChange (self);
    XScaleBar.Position := round (ParsFloat (FMarkStr, 'sx', 1) * 10);
    XScaleBarChange (self);
    YScaleBar.Position := YScaleBar.Max + 1
      - round (ParsFloat (FMarkStr, 'sy', 1) * 10);
    YScaleBarChange (self);
//    YScaleBar.visible := true;
//    XScaleBar.visible := true;

(*    if EqualCheck.Checked then begin
      ZScaleBar.Position := ZScaleBar.max + 1
        - round (ParsFloat (FMarkStr, 'sz', 1) * 10);
      ZScaleBarChange (self);
      XScaleBar.Position := XScaleBar.Max + 1 - ZScaleBar.Position;
      YScaleBar.Position := ZScaleBar.Position;
      YScaleBar.visible := false;
      XScaleBar.visible := false;
    end else begin
      ZScaleBar.Position := ZScaleBar.max + 1
        - round (ParsFloat (FMarkStr, 'sz', 1) * 10);
      ZScaleBarChange (self);
      XScaleBar.Position := round (ParsFloat (FMarkStr, 'sx', 1) * 10);
      XScaleBarChange (self);
      YScaleBar.Position := YScaleBar.Max + 1
        - round (ParsFloat (FMarkStr, 'sy', 1) * 10);
      YScaleBarChange (self);
      YScaleBar.visible := true;
      XScaleBar.visible := true;
    end;*)

    ScalePanel.visible := true;
  end else ScalePanel.visible := false;

  if ParsInt (FMarkStr, 'rot', 0) > 0 then begin
    XRotBar.Position := round (ParsFloat (FMarkStr, 'rx', 0));
    XRotBarChange (self);

    ca := ParsInt (FMarkStr, 'ca', 0);
    AngleCheck.Checked := (ca > 0);
    if AngleCheck.Checked then begin
      YRotBar.Position := round (iiAngle);
      YRotBar.visible := false;
    end else begin
      YRotBar.Position := -round (ParsFloat (FMarkStr, 'ry', 0));
      YRotBar.visible := true;
    end;
    YRotBarChange (self);

    ZRotBar.Position := -round (ParsFloat (FMarkStr, 'rz', 0) );
    ZRotBarChange (self);

    RotationPanel.visible := true;
  end else RotationPanel.visible := false;

  if ParsInt (FMarkStr, 'shad', 0) > 0 then begin
    ShadowCheck.visible := true;
    ShadowCheck.Checked := ParsInt (FMarkStr, 'sh', 0) > 0;
  end else ShadowCheck.visible := false;
end;

procedure TMain.PaintMark; {-----------------------------------}
var
  xxc,yyc: integer;     // top-left-posision of pixel
  xxm,yym: integer;     // center in the pixel
  xxmrk,yymrk: integer; // start-position of the markframes
  sx,sy,rz: double;     // scale and rotation
  xl,xr,yt,yb: double;  // differences to the rotation point
  x1,x2,x3,x4,y1,y2,y3,y4: double;  // corners after rotation
  xx1,xx2,xx3,xx4,yy1,yy2,yy3,yy4: integer; // corners on the bitmap

begin
  xxc := ParsInt(FMarkStr,'x',0) * mpScale;
  yyc := ParsInt(FMarkStr,'y',0) * mpScale;
  xxm := xxc+mpScale div 2;
  yym := yyc+mpScale div 2;
  xxmrk := xxc+mpScale-1;
  yymrk := yyc+mpScale-1;
  // draw markframes
  with MMap.Canvas do begin
    Brush.Style:=bsClear;
    Pen.Mode:=pmNotXor;
    Rectangle(xxc-2,yyc-2,xxmrk+3,yymrk+3);
    if mpScale>2 then Rectangle(xxc-3,yyc-3,xxmrk+4,yymrk+4);
    if mpScale>4 then Rectangle(xxc-4,yyc-4,xxmrk+5,yymrk+5);
    if AreaFlag='a' then begin
      // read scale and rotation
      sx:=ParsFloat(FMarkStr,'sx',1);
      sy:=ParsFloat(FMarkStr,'sy',1);
      rz:=-ParsFloat(FMarkStr,'rz',0)*pi/180;
      // read differences to rotation point
      xl:=ParsFloat(FMarkStr,'xl',0)*sx;
      xr:=ParsFloat(FMarkStr,'xr',0)*sx;
      yt:=ParsFloat(FMarkStr,'yt',0)*sy;
      yb:=ParsFloat(FMarkStr,'yb',0)*sy;
      // rotate points
      RotatePoint(rz,xl,yt,x1,y1);
      RotatePoint(rz,xr,yt,x2,y2);
      RotatePoint(rz,xr,yb,x3,y3);
      RotatePoint(rz,xl,yb,x4,y4);
      // compute coordinates on the bitmap
      xx1:=xxm+round(x1*iiWidth/iiCourseWidth*mpScale);
      xx2:=xxm+round(x2*iiWidth/iiCourseWidth*mpScale);
      xx3:=xxm+round(x3*iiWidth/iiCourseWidth*mpScale);
      xx4:=xxm+round(x4*iiWidth/iiCourseWidth*mpScale);
      yy1:=yym+round(y1*iiHeight/iiCourseLength*mpScale);
      yy2:=yym+round(y2*iiHeight/iiCourseLength*mpScale);
      yy3:=yym+round(y3*iiHeight/iiCourseLength*mpScale);
      yy4:=yym+round(y4*iiHeight/iiCourseLength*mpScale);
      // draw rectangle
      with MMap.Canvas do begin
        Moveto(xx1,yy1);
        LineTo(xx2,yy2);
        LineTo(xx3,yy3);
        LineTo(xx4,yy4);
        LineTo(xx1,yy1);
      end;
    end else if AreaFlag='y' then begin
      sx:=ParsFloat(FMarkStr,'sx',1);
      sy:=ParsFloat(FMarkStr,'sy',1);
      rz:=-ParsFloat(FMarkStr,'rz',0)*pi/180;
      yt:=ParsFloat(FMarkStr,'yt',0)*sy;
      yb:=ParsFloat(FMarkStr,'yb',0)*sy;
      RotatePoint(rz,0,yt,x1,y1);
      RotatePoint(rz,0,yb,x2,y2);
      xx1:=xxm+round(x1*iiWidth/iiCourseWidth*mpScale);
      xx2:=xxm+round(x2*iiWidth/iiCourseWidth*mpScale);
      yy1:=yym+round(y1*iiHeight/iiCourseLength*mpScale);
      yy2:=yym+round(y2*iiHeight/iiCourseLength*mpScale);
      // draw Line
      with MMap.Canvas do begin
        Moveto(xx1,yy1);
        LineTo(xx2,yy2);
      end;
    end else if AreaFlag='x' then begin
      sx:=ParsFloat(FMarkStr,'sx',1);
      sy:=ParsFloat(FMarkStr,'sy',1);
      rz:=-ParsFloat(FMarkStr,'rz',0)*pi/180;
      xl:=ParsFloat(FMarkStr,'xl',0)*sx;
      xr:=ParsFloat(FMarkStr,'xr',0)*sx;
      RotatePoint(rz,xl,0,x1,y1);
      RotatePoint(rz,xr,0,x2,y2);
      xx1:=xxm+round(x1*iiWidth/iiCourseWidth*mpScale);
      xx2:=xxm+round(x2*iiWidth/iiCourseWidth*mpScale);
      yy1:=yym+round(y1*iiHeight/iiCourseLength*mpScale);
      yy2:=yym+round(y2*iiHeight/iiCourseLength*mpScale);
      with MMap.Canvas do begin
        Moveto(xx1,yy1);
        LineTo(xx2,yy2);
      end;
    end;
    Brush.Style:=bsSolid;
    Pen.Mode:=pmCopy;
  end;
  PaintClient;
end;

procedure TMain.OpenEditState; {-------------------------------}
begin
  SetMark (idx);
  ReadEditParams;
end;

procedure TMain.CloseEditState; {------------------------------}
var shape: String;
    mr: TRect;
    x,y: integer;
begin
  if FMarkNum >= 0 then begin
    OArr[FMarkNum] := FMarkStr;
    ResetMark;
    shape := ParsStr (FMarkStr, 'shape');
    if (pos('a', shape) > 0) or (pos('x', shape) > 0)
    or (pos('y', shape) > 0) then begin
      x := ParsInt (FMarkStr, 'x', -1);
      y := ParsInt (FMarkStr, 'y', -1);
      RegenerateObjectRect (x, y);
    end else begin  // object without outlines
    end;
  end;
end;

procedure TMain.SetMark; {-------------------------------------}
var i,x,y:integer;
begin
  ResetMark;
  if (idx >= 0) and (idx < OArr.Count) then begin
    FMarkNum := idx;
    FMarkStr := OArr[idx];
    AreaFlag := ParsStr (FMarkStr, 'shape');
    PaintMark;
  end;
end;

procedure TMain.ResetMark; {-----------------------------------}
begin
  if FMarkNum < 0 then exit;
  if FMarkNum > OArr.Count-1 then begin
    FMarkNum := -1;
    exit;
  end;
  PaintMark;
  OArr[FMarkNum] := FMarkStr;
  FMarkNum := -1;
  AreaFlag := '';
end;

function TMain.ObjFind; {--------------------------------------}
begin
  Result := ParsInt (OIdx, IntToStr(x) + '-' + IntToStr(y), -1);
end;

function TMain.ObjFindNear; {----------------------------------}
var idx: integer;
begin
  idx := ObjFind (x, y);
  if idx < 0 then idx := ObjFind (x, y-1);
  if idx < 0 then idx := ObjFind (x, y+1);
  if (idx < 0 ) and (x > 0) then begin
    idx := ObjFind (x-1, y);
    if idx < 0 then idx := ObjFind (x-1, y-1);
    if idx < 0 then idx := ObjFind (x-1, y+1);
  end;
  if (idx < 0) and (x < iiWidth-1) then begin
    idx := ObjFind (x+1, y);
    if idx < 0 then idx := ObjFind (x+1, y-1);
    if idx < 0 then idx := ObjFind (x+1, y+1);
  end;
  Result := idx;
end;

function TMain.GetObjTyp; {------------------------------------}
var idx: integer;

function Item_Num (item: string): integer; {...................}
var po: integer;
    ss: string;
begin
  po:=pos (' ', item);
  ss:=copy (item, 1, po-1);
  Result := Str_Int(ss, 0);
end;

begin {........................................................}

  if ObjectRegister.ActivePage = common then begin
    if CommonList.ItemIndex >= 0 then begin
       Result := Item_Num (CommonList.Items [CommonList.ItemIndex]);
    end else Result := -1;
  end else if ObjectRegister.ActivePage = trees then begin
    if TreesList.ItemIndex >= 0 then begin
       Result := Item_Num (TreesList.Items [TreesList.ItemIndex]);
    end else Result := -1;
  end else if ObjectRegister.ActivePage = rocks then begin
    if RocksList.ItemIndex >= 0 then begin
       Result := Item_Num (RocksList.Items [RocksList.ItemIndex]);
    end else Result := -1;
  end else if ObjectRegister.ActivePage = houses then begin
    if HousesList.ItemIndex >= 0 then begin
       Result := Item_Num (HousesList.Items [HousesList.ItemIndex]);
    end else Result := -1;
  end else if ObjectRegister.ActivePage = bridges then begin
    if BridgesList.ItemIndex >= 0 then begin
       Result := Item_Num (BridgesList.Items [BridgesList.ItemIndex]);
    end else Result := -1;
  end else if ObjectRegister.ActivePage = misc then begin
    if MiscList.ItemIndex >= 0 then begin
       Result := Item_Num (MiscList.Items [MiscList.ItemIndex]);
    end else Result := -1;
  end else Result := -1;
end;


procedure TMain.ReadObjects; {---------------------------------}
var i, typ: integer;
    ss, sss, grp, cup, cp: String;
const CupIdx: String = '[beginner]a[arctic]a[forest]f[mountain]m[glacier]g[swiss]s[]';
begin
  CommonList.Clear;
  TreesList.Clear;
  RocksList.Clear;
  HousesList.Clear;
  BridgesList.Clear;
  MiscList.Clear;
  cp := ParsStr (CupIdx, iiCupName);
  if OList.count > 0 then for i := 0 to OList.count-1 do begin
    ss := OList[i];
    typ := ParsInt (ss, 'type', 0);
    grp := ParsStr (ss, 'grp');
    cup := ParsStr (ss, 'cup');
    if (cup = 'c') or (iiCupName = 'share') or (pos (cp, cup) > 0) then begin
      sss := IntToStr (typ) + '   ' + ParsStr (OList[i], 'trivname');
      if grp = 'c' then begin
        CommonList.Items.Add (sss);
      end else if grp = 't' then begin
        TreesList.Items.Add (sss);
      end else if grp = 'r' then begin
        RocksList.Items.Add (sss);
      end else if grp = 'h' then begin
        HousesList.Items.Add (sss);
      end else if grp = 'b' then begin
        BridgesList.Items.Add (sss);
      end else if grp = 'm' then begin
        MiscList.Items.Add (sss);
      end;
    end;
  end;
  if CommonList.Items.Count > 0 then CommonList.ItemIndex := -1;
  if TreesList.Items.Count > 0 then TreesList.ItemIndex := -1;
  if RocksList.Items.Count > 0 then RocksList.ItemIndex := -1;
  if HousesList.Items.Count > 0 then HousesList.ItemIndex := -1;
  if BridgesList.Items.Count > 0 then BridgesList.ItemIndex := -1;
  if MiscList.Items.Count > 0 then MiscList.ItemIndex := -1;
end;

procedure TMain.SetTerrBrush; {-----------------------------}
const hsize: array[1..8] of byte = (1,2,3,5,7,9,13,21);
begin
  if mpTerrBrush = brush then exit;
  mpTerrBrush := brush;
  mpTerrBrushSize:=hsize[brush];
  mpTerrDist := mpTerrBrushSize div 6;
  if mpTerrDist < 1 then mpTerrDist := 1;
  if mpTerrDist > 3 then mpTerrDist := 3;
end;

procedure TMain.SetElevBrush; {-----------------------------}
const intens :  array [9..16] of byte = (70,60,50,50,50,50,50,50);
      softsize: array [9..16] of byte = (3,5,7,9,13,17,23,31);
      hardsize: array [1..8]  of byte = (1,2,3,5,7,9,13,21);
begin
  if mpElevBrush = brush then exit;
  mpElevBrush := brush;
  if brush < 9 then begin
    GenerateBrush (hardsize[brush], 100, false);
  end else if brush in [9..16] then begin
    GenerateBrush (softsize[brush], intens[brush], true);
  end;
  if mpElevTool = etDark then mpPaintLock := (mpElevBrush < 9);
end;

procedure TMain.ResetElevTool;
begin
  mpElevTool := etBrush;
  mpMaskMode := 0;
  BrushButt.Down := true;
  SoftBrushCover.visible := false;
  MaskPanel.visible := false;
  BrightPanel.visible := false;
  BlurPanel.visible := false;
  SprayPanel.visible := false;
  elevbrush.brush := 3;
  SetElevBrush (3);
  ClearMaskArr;
end;


procedure TMain.SetElevTool; {---------------------------------}
begin
  if mpElevTool = tool then exit;

  if EditMode = emTerr then begin
    mpElevTool := etBrush;
  end else if EditMode = emElev then begin
    if tool = etDark then mpPaintLock := (mpElevBrush < 9)
      else mpPaintLock := false;
    if tool = etMask then mpMaskMode := 1 else mpMaskMode := 0;
    if (tool = etMask) or (mpElevTool = etMask) then begin
      EArr_MMap;
      PaintClient;
    end;
    mpElevTool := tool;
  end;
  GreyScale.ResetMark;

  if tool = etDark then begin
    BrightPanel.visible := true;
    BrightBar.Position := mpBright;
    BrightDisp.Caption := IntToStr (BrightBar.Position);
  end else begin
    BrightPanel.visible := false;
  end;

  if tool = etMask then begin
    MaskPanel.visible := true;
    MaskPaintButton.Down := true;
    if mpElevBrush > 8 then begin
      ElevBrush.brush := mpElevBrush - 8;
      SetElevBrush (mpElevBrush - 8);
    end;
    SoftBrushCover.visible := true;
  end else begin
    MaskPanel.visible := false;
    SoftBrushCover.visible := false;
  end;;

  if tool = etBlur then begin
    BlurPanel.visible := true;
    BlurBar.Position := mpBlur;
    BlurDisp.Caption := IntToStr (BlurBar.Position);
  end else begin
    BlurPanel.visible := false;
  end;

  if tool = etSpray then begin
    SprayPanel.visible := true;
  end else begin
    SprayPanel.visible := false;
  end;
end;

procedure TMain.SetObjectTool; {-------------------------------}
begin
  ObjectTool := tool;
  case Tool of
    otEdit: OEditButton.Down := true;
    otAdd: OAddButton.Down := true;
    otMulti: OMultiButton.Down := true;
    otDel: ODelButton.Down := true;
  end;
end;

procedure TMain.SetObjBright; {--------------------------------}
begin
  if mpObjBright = bright then exit;
  mpObjBright := bright;
  if iiOpen then case EditMode of
    emObj: begin
      EArr_MMap;
      M_StoreMMap;
      PaintFinishLine;
      PaintObjects;
      PaintClient;
      end;
    emTarg: begin
      EArr_MMap;
//      PaintTargets;
      PaintClient;
      end;
  end;
end;

procedure TMain.SetMix; {--------------------------------------}
begin
  if mpMix = mix then exit;
  mpMix := mix;
  if iiOpen then begin
    TMap_MMap;
//  PaintObjects;
    PaintClient;
  end;
end;

procedure TMain.SetScale; {------------------------------------}
begin
  if mpScale = scale then exit;
  mpScale := scale;
  if mpScale < 1 then mpScale := 1;
  if mpScale > 5 then mpScale := 5;

  if iiOpen then begin
    B_SetMapSize; // setzt MMap und MMap2 auf Skalierung
    case EditMode of
      emCourse: begin
        end;
      emElev: begin
        EArr_MMap;
        PaintClient;
        end;
      emTerr: begin
        TMap_MMap;
        PaintClient;
        end;
      emObj:  begin
        EArr_MMap;
        M_StoreMMap;
        PaintFinishLine;
        PaintObjects;
        PaintClient;
        end;
      emTarg: begin
        EArr_MMap;
        PaintClient;
        end;
    end; // of case
  end;
  ClientScroll.VertScrollBar.Position := 0;
  ClientScroll.HorzScrollBar.Position := 0;
end;

procedure TMain.SetEditMode; {---------------------------------}
begin
//  if mode = EditMode then exit;
  {--- tasks be leaving a mode ---}
  ODispPanel.caption := '';
  case EditMode of
    emCourse: begin
      CourseLabel.visible := false;
      end;
    emElev: begin
      SetElevTool (etBrush);
      BrushButt.Down := true;
      end;
    emTerr: begin
      end;
    emObj: begin
      CloseEditState;
//      ObjEditPanel.visible := false;
        ORegister.ActivePage := oselect;
      end;
    emTarg: begin
      end;
  end;

  EditMode := mode;
  {--- tasks by entering a new mode ---}
  case EditMode of
    emCourse: begin
      CourseLabel.visible := true;
      ClientRegister.ActivePage := course;
      InfoPanel.visible := not iiOpen;
      CourseButton.Down := true;
      PaintClient;
      ClientScroll.VertScrollBar.Position := 0;
      end;
    emElev: begin
      ClientRegister.ActivePage := elevation;
      InfoPanel.visible := false;
      ElevationButton.Down := true;
      EArr_MMap;
      PaintClient;
      end;
    emTerr: begin
      ClientRegister.ActivePage := terrain;
      InfoPanel.visible := false;
      TerrainButton.Down := true;
      TMap_MMap;
      PaintClient;
      end;
    emObj: begin
      ClientRegister.ActivePage := objects;
      InfoPanel.visible := false;
      ObjectsButton.Down := true;
      EArr_MMap;
      M_StoreMMap;
      PaintFinishLine;
      PaintObjects;
      PaintClient;
      SetObjectTool (otEdit);
      end;
    emTarg: begin
      ClientRegister.ActivePage := targets;
      InfoPanel.visible := false;
      TargetsButton.Down := true;
      EArr_MMap;
      PaintClient;
//      PaintTargets;
      end;
    emIntern: begin
      ClientRegister.ActivePage := internal;
      InfoPanel.visible := false;
      InternalButton.Down := true;
      end;
    emScript: begin
      ClientRegister.ActivePage := script;
      InfoPanel.visible := false;
      ScriptButton.Down := true;
      end;
  end;
end;

procedure TMain.Init; {----------------------------------------}
var i: integer;
begin
  iiShowOutlines := false;
  WithoutOutlineButton.Down := true;
  iiOutlineCol := clAqua; //clAqua;
  iiRefreshSize := 40;
  ObjUnvisibButton.Down := true;

  iiTuxBin := '';
  iiCourseDir := '';
  iiCourseDirOK := false;
  iiTerrlistOK := false;
  iiObjlistOK := false;
  iiHomeDir := HomeDir;
  iiConfDir := HomeDir + SEP + '.tuxeditor';
  iiOpen := false;

  EMap := TBitmap.Create;
  EMap.PixelFormat := pf32bit;
  TMap := TBitmap.Create;
  TMap.PixelFormat := pf32bit;
  MMap := TBitmap.Create;
  MMap.PixelFormat := pf32bit;
  MMap2 := TBitmap.Create;
  MMap2.PixelFormat := pf32bit;
  OArr := TStringList.Create;
  OList := TStringList.Create;
  for i := 1 to MaxTerrStore do TerrStore[i] := TBitmap.Create;
  for i := 1 to MaxTerrStore do TerrStore[i].PixelFormat := pf32bit;

  mpScale := 3;
  ScaleButt3.down := true;
  mpObjBright := 3;
  ObjBrightButt3.Down := true;
  mpMix := 4;
  MixBar.Position := 4;
  mpMaskMode := 0;
  iiMaskCol := cCol (150,0,0);
  iiUnmaskCol := cCol (0,0,100);
  mpElevGrey := 0;
  ForePanel.Color := clBlack;
  mpBackGrey := 255;
  BackPanel.Color := clWhite;
  mpElevTool := etBrush;
  BrushButt.down := true;
  mpBlur := 10;
  BlurPanel.visible := false;
  mpElevDist := 1;
  mpBright := 20;
  mpPaintLock := false;
  mpMinSpray := -10;
  MinSprayBar.Position := -10;
  MinSprayDisp.caption := '-10';
  mpMaxSpray := 10;
  MaxSprayBar.Position := 10;
  MaxSprayDisp.Caption := '10';
  mpVall := 0;
  VallBar.Position := 0;
  VallDisp.Caption := '0';
  mpMount := 255;
  MountBar.Position := 255;
  MountDisp.Caption := '255';
  mpBasementAngle := 0;
  BasementBar.Position := 0;
  BasementDisp.caption := IntToStr (mpBasementAngle) + ' ';

  ObjectRegister.ActivePage := common;
  ORegister.ActivePage := oselect;

  {-- modes ---}
  EditMode := emNone;
  SetEditMode (emCourse);
  ObjectTool := otNone;
  SetObjectTool (otEdit);

  mpClientCanvas := Client.Canvas;
  if not DirectoryExists (iiConfDir) then ForceDirectories (iiConfDir);

  GreyScale.Init;
  ElevBrush.Init;
  TerrPalette.Init;
  TerrBrush.Init;

  mpTerrBrush := 0;
  SetTerrBrush (1);
  mpElevBrush := 0;
  SetElevBrush (3);
  ElevBrush.Brush := 3;
  mpTerrCol := clWhite;
  TerrColPanel.Color := clWhite;
  ObjectRegister.ActivePage := common;
  CommonButton.Down := true;

  B_LoadConfig;
  B_LoadObjlist;
  B_CheckStructure (CourseDirPanel);
  ButtonDown := false;

  FMarkNum := -1;
end;

procedure TMain.OpenCourse; {----------------------------------}
var ss: String;
    ok: boolean;
begin
  if not iiCourseDirOK then exit;  // no path set

  OpenDialog.InitialDir := iiCourseDir;
  OpenDialog.Filter := 'Tuxeditor course descriptor (course.tcl)|course.tcl';
  if OpenDialog.Execute then begin
    CloseCourse;
    {--- check folders and files ---}
    SeparateOSPath (OpenDialog.Filename, iiTrackDir, ss);
    iiOpen := (FileExists (B_ElevFile)) and (FileExists (B_TerrainFile));
    if iiOpen then begin
      SeparateOSPath (iiTrackDir, iiCupDir, iiTrackName);
      SeparateOSPath (iiCupDir, ss, iiCupName);
      iiOpen := (FileExists (B_ObjectsFile)) and (FileExists (B_OTexturesFile));
      if iiOpen then begin
        iiObjResource := iiCupName;
        if iiObjResource = 'beginner' then iiObjResource := 'arctic';
        iiOpen := (FileExists (B_CourseFile)); // and (FileExists (B_ItemsFile));
      end;
    end;

    {--- open files ---}
    if iiOpen then begin
      F_LoadBitmaps;    // load elev and terrain
      B_SetMapSize;     // set size of MMap to EMap (=TMap)
      EMap_EArr;        // creates EArr, must be done before FLoadObjects
      F_LoadCourseTCL;  // load course.tcl
      iiCourseChanged := true;
      F_SaveCourseTCL;  // use own course.tcl only (no animated objects)
      ReadCourseParams; // set params to panel
      F_LoadObjects;
      ReadObjects;
      InfoPanel.visible := false;
      ResetTerrStore;
      ResetElevStore;
      ResetElevTool;
      ButtonCoverPanel1.visible := false;
      ButtonCoverPanel2.visible := false;
    end else begin
    end;

  end;

  {--- reset edit flags ---}
  iiElevChanged := false;
  iiTerrChanged := false;
  iiCourseChanged := false;
  iiObjChanged := false;
  iiTargChanged := false;
end;

procedure TMain.CloseCourse; {---------------------------------}
begin
  if iiTerrChanged or iiObjChanged or iiElevChanged then begin
    SaveQueryForm.CancelButton.visible := false;
    if SaveQueryForm.ShowModal = mrYes then SaveCourse;
  end;
  SaveCourse;
  iiOpen := false;
  SetEditMode (emCourse);
  ButtonCoverPanel1.visible := true;
  ButtonCoverPanel2.visible := true;
end;

procedure TMain.SaveCourse; {----------------------------------}
begin
  if not iiOpen then exit;
  if EditMode = emObj then begin
    CloseEditState;
    ORegister.ActivePage := oselect;
  end;
  if iiElevChanged then iiObjChanged := true;
  F_SaveElev;
  F_SaveTerr;
  F_SaveObjects;
end;

procedure TMain.PaintClient; {---------------------------------}
var c: TCanvas;
    bo, len, wid, dest: integer;
begin
  c := Client.Canvas;
  if not iiOpen then begin  // only rectangle
    CourseLabel.visible := false;
    Client.Height := 400;
    Client.Width := 200;
    c.brush.color := coDarkBlue;
    c.rectangle (-1, -1, 500, 3000);
    c.font.color := $00BBBBBB;
    c.font.size := 12;
    c.font.style := [];
    c.font.color := $00FFAA55;
    c.font.size := 14;
    c.font.style := [fsBold];
    c.textout (10,10, 'Tuxeditor 0.5');
  end else if EditMode = emCourse then begin // course plan
    CourseLabel.visible := true;
    Client.Height := 40;
    Client.Width := 10;
    c.brush.color := $00783c1e;
    c.pen.color := c.brush.color;
    c.rectangle (-1, -1, 12, 42);
    CourseLabel.left := 20;
    CourseLabel.caption := iiTrackName;
  end else begin  // course bitmap (MMap)
    Client.Height := EMap.height * mpScale;
    Client.Width := EMap.Width * mpScale;
    Client.Canvas.Draw (0, 0, MMap);
  end;
end;

procedure TMain.PaintObjects; {--------------------------------}
var i: integer;
begin
  for i := 0 to OArr.Count-1 do PaintObject (i);
  if FMarkNum >= 0 then PaintMark;
end;

procedure TMain.PaintObjectsRect; {-----------------------------}
var i,x,y: integer;
begin
//  if mpObjVisible then begin
    for i := 0 to OArr.Count-1 do begin
      x:= ParsInt (OArr[i],'x',-1);
      y:= ParsInt (OArr[i],'y',-1);
      if (x>r.left) and (x<r.right) and (y>r.top) and (y<r.bottom)
        then PaintObject (i);
    end;
    if FMarkNum >= 0 then PaintMark;
//  end;
end;

procedure TMain.RegenerateObjectRect; {---------------------}
var mr,pr: TRect;
begin
  {setting mr for restoring maprect}
  with mr do begin
    top := (y - iiRefreshSize) * mpScale;
    left := (x - iiRefreshSize) * mpScale;
    bottom := (y + iiRefreshSize) * mpScale;
    right := (x + iiRefreshSize) * mpScale;
    if top < 0 then top := 0;
    if left < 0 then left := 0;
    if right >= MMap.width then right := MMap.width - 1;
    if bottom >= MMap.height then bottom := MMap.height - 1;
  end;
  M_RecallMMapRect (mr);
  {setting pr for repainting objects}
  with pr do begin
    left := x - iiRefreshSize - 30;
    top := y - iiRefreshSize - 30;
    right := x + iiRefreshSize + 30;
    bottom := y + iiRefreshSize + 30;
  end;
  PaintFinishLine;
  PaintObjectsRect (pr);
  PaintClient;
end;

procedure TMain.PaintObject; {---------------------------------}
var x,y,r,g,b:integer;
    ss:String;
    sx,sy,rz, xl,xr,yt,yb : double;
    x1,x2,x3,x4,y1,y2,y3,y4: double;  // corners after rotation
    xx1,xx2,xx3,xx4,yy1,yy2,yy3,yy4: integer; // corners on the bitmap
    xxm,yym,xxc,yyc: integer;     // center in the pixel
    shape: String;
begin
  if (idx < 0) or (idx >= OArr.Count) then exit;
  ss := OArr[idx];
  x := ParsInt (ss, 'x', -1);
  y := ParsInt (ss, 'y', -1);
  r := ParsInt (ss, 'red', 0);
  g := ParsInt (ss, 'grn', 0);
  b := ParsInt (ss, 'blue', 0);
  O_PaintOPixel (x, y, cCol (r,g,b));

  if iiShowOutlines then begin
    xxc := ParsInt (ss,'x',0) * mpScale;  // auf skalierte Map hochgerechnet
    yyc := ParsInt (ss,'y',0) * mpScale;
    xxm := xxc + mpScale div 2;
    yym := yyc + mpScale div 2;

    shape := ParsStr (ss, 'shape');
    if shape = 'a' then begin
      sx :=  ParsFloat (ss, 'sx', 1);
      sy :=  ParsFloat (ss, 'sy', 1);
      rz := -ParsFloat (ss, 'rz', 0) * pi / 180;

      xl :=  ParsFloat (ss, 'xl', 0) * sx;
      xr :=  ParsFloat (ss, 'xr', 0) * sx;
      yt :=  ParsFloat (ss, 'yt', 0) * sy;
      yb :=  ParsFloat (ss, 'yb', 0) * sy;

      RotatePoint (rz, xl, yt, x1, y1);
      RotatePoint (rz, xr, yt, x2, y2);
      RotatePoint (rz, xr, yb, x3, y3);
      RotatePoint (rz, xl, yb, x4, y4);

      xx1 := xxm + round (x1 * iiWidth / iiCourseWidth * mpScale);
      xx2 := xxm + round (x2 * iiWidth / iiCourseWidth * mpScale);
      xx3 := xxm + round (x3 * iiWidth / iiCourseWidth * mpScale);
      xx4 := xxm + round (x4 * iiWidth / iiCourseWidth * mpScale);
      yy1 := yym + round (y1 * iiHeight / iiCourseLength * mpScale);
      yy2 := yym + round (y2 * iiHeight / iiCourseLength * mpScale);
      yy3 := yym + round (y3 * iiHeight / iiCourseLength * mpScale);
      yy4 := yym + round (y4 * iiHeight / iiCourseLength * mpScale);

//      objviewpanel.caption := floattostr(x1);

      with MMap.Canvas do begin
        pen.color := iiOutlineCol;
        Moveto (xx1, yy1);
        LineTo (xx2, yy2);
        LineTo (xx3, yy3);
        LineTo (xx4, yy4);
        LineTo (xx1, yy1);
      end;

    end else if shape = 'x' then begin
      sx :=  ParsFloat (ss, 'sx', 1);
      sy :=  ParsFloat (ss, 'sy', 1);
      rz := -ParsFloat (ss, 'rz', 0) * pi / 180;
      xl :=  ParsFloat (ss, 'xl', 0) * sx;
      xr :=  ParsFloat (ss, 'xr', 0) * sx;
      RotatePoint (rz, xl, 0, x1, y1);
      RotatePoint (rz, xr, 0, x2, y2);
      xx1 := xxm + round (x1 * iiWidth / iiCourseWidth * mpScale);
      xx2 := xxm + round (x2 * iiWidth / iiCourseWidth * mpScale);
      yy1 := yym + round (y1 * iiHeight / iiCourseLength * mpScale);
      yy2 := yym + round (y2 * iiHeight / iiCourseLength * mpScale);
      with MMap.canvas do begin
        Pen.Color := iiOutlineCol;
        Moveto (xx1, yy1);
        LineTo (xx2, yy2);
      end;

    end else if shape = 'y' then begin
      sx :=  ParsFloat (ss, 'sx', 1);
      sy :=  ParsFloat (ss, 'sy', 1);
      rz := -ParsFloat (ss, 'rz', 0) * pi / 180;
      yt :=  ParsFloat (ss, 'yt', 0) * sy;
      yb :=  ParsFloat (ss, 'yb', 0) * sy;
      RotatePoint (rz, 0, yt, x1, y1);
      RotatePoint (rz, 0, yb, x2, y2);
      xx1 := xxm + round (x1 * iiWidth / iiCourseWidth * mpScale);
      xx2 := xxm + round (x2 * iiWidth / iiCourseWidth * mpScale);
      yy1 := yym + round (y1 * iiHeight / iiCourseLength * mpScale);
      yy2 := yym + round (y2 * iiHeight / iiCourseLength * mpScale);
      with MMap.canvas do begin
        Pen.Color := iiOutlineCol;
        Moveto (xx1, yy1);
        LineTo (xx2, yy2);
      end;
    end;
  end; {of outlines}
end;

procedure TMain.ReadCourseParams; {----------------------------}
begin
  iiHeightEdit.caption := ' ' + IntToStr (iiHeight);
  iiWidthEdit.caption := ' ' + IntToStr (iiWidth);
  iiTrackPanel.caption := ' ' + iiTrackName;
  iiCupPanel.caption := ' ' + iiCupName;

  coWEdit.caption := ' ' + FloatToStr (iiCourseWidth);
  coLEdit.caption := ' ' + FloatToStr (iiCourseLength);
  coPlayWEdit.caption := ' ' + FloatToStr (iiPlayWidth);
  coPlayLEdit.caption := ' ' + FloatToStr (iiPlayLength);
  coAngleEdit.caption := ' ' + FloatToStr (iiAngle);
  coScaleEdit.caption := ' ' + FloatToStr (iiScale);
  coStartEdit.caption := ' ' + iiStartStr;
end;

{--------------------------------------------------------------}
{                       Form                                   }
{--------------------------------------------------------------}

procedure TMain.FormCreate; {==================================}
begin
  top:=0; left:=0; height:=560; width:=800;
  DecimalSeparator := '.';
  Randomize;
  Init;
end;

procedure TMain.FormShow; {====================================}
begin
  begin end;
end;

procedure TMain.FormClose; {===================================}
begin
  B_SaveConfig;
end;

procedure TMain.FormDestroy; {=================================}
var i: integer;
begin
  EMap.Free;
  TMap.Free;
  MMap.Free;
  MMap2.Free;
  OArr.Free;
  OList.Free;
  for i := 1 to MaxTerrStore do TerrStore[i].Free;
end;

procedure TMain.ClientPaint; {---------------------------------}
begin
  PaintClient;
end;

procedure TMain.CourseEditButtonClick(Sender: TObject);
begin
  with CourseParamsForm do begin
    LengthEdit.text := FloatToStr (iiCourseLength);
    WidthEdit.text := FloatToStr (iiCourseWidth);
    PlayLengthEdit.text := FloatToStr (iiPlayLength);
    PlayWidthEdit.text := FloatToStr (iiPlayWidth);
    ScaleEdit.text := FloatToStr (iiScale);
    AngleEdit.text := FloatToStr (iiAngle);
    StartEdit.text := iiStartStr;
  end;
  if CourseParamsForm.ShowModal = mrOK then begin
    with CourseParamsForm do begin
      iiCourseLength := Str_Float (LengthEdit.text, iiCourseLength);
      iiCourseWidth := Str_Float (WidthEdit.text, iiCourseWidth);
      iiPlayLength := Str_Float (PlayLengthEdit.text, iiPlayLength);
      iiPlayWidth := Str_Float (PlayWidthEdit.text, iiPlayWidth);
      iiScale := Str_Float (ScaleEdit.text, iiScale);
      iiAngle := Str_Float (AngleEdit.text, iiAngle);
      iiStartStr := StartEdit.text;
    end;
    iiCourseChanged := true;
    iiObjChanged := true;
    F_SaveCourseTCL;
    ReadCourseParams;
  end;
end;

procedure TMain.GreyscaleSelect; {-----------------------------}
begin
  ForePanel.Color := color;
  mpElevGrey := grey;
end;

procedure TMain.TerrPaletteSelect(Color: TColor; TerrName: String);
begin
  mpTerrCol := color;
  TerrColPanel.Color := color;
//  TerrNamePanel.caption := '  ' + TerrName;
end;

procedure TMain.TerrBrushSelect(nr: Integer);
begin
  SetTerrBrush (nr);
end;

procedure TMain.XDiffBarChange(Sender: TObject);
var d: double;
begin
  d:=XDiffBar.Position / 10;
  XDiffPanel.caption:=Float_Str(d,1);
  SetParsStr(FMarkStr,'dx',XDiffPanel.caption);
end;

procedure TMain.YDiffBarChange(Sender: TObject);
var d: double;
begin
  d:=YDiffBar.Position / 10;
  YDiffPanel.caption:=Float_Str(d,1);
  SetParsStr(FMarkStr,'dy',YDiffPanel.caption);
end;

procedure TMain.ZDiffBarChange(Sender: TObject);
var d: double;
begin
  d := (200 - ZDiffBar.position) / 10;
  ZDiffPanel.caption := Float_Str(d,2);
  SetParsStr (FMarkStr, 'dz', ZDiffPanel.caption);
end;

procedure TMain.XScaleBarChange(Sender: TObject);
var d: double;
begin
  d:=XScaleBar.Position/10;
  XScalePanel.caption:=Float_Str(d,2);
  if AreaFlag<>'' then PaintMark;
  SetParsStr(FMarkStr,'sx',XScalePanel.caption);
  if AreaFlag<>'' then PaintMark;

(*  if EqualCheck.Checked then begin
    YScaleBar.Position:=YScaleBar.Max+1-XScaleBar.Position;
    ZScaleBar.Position:=ZScaleBar.Max+1-XScaleBar.Position;
  end;*)
end;

procedure TMain.YScaleBarChange(Sender: TObject);
var d: double;
begin
  d:=(YScaleBar.Max+1-YScaleBar.Position)/10;
  YScalePanel.caption:=Float_Str(d,2);
  if AreaFlag<>'' then PaintMark;
  SetParsStr(FMarkStr,'sy',YScalePanel.caption);
  if AreaFlag<>'' then PaintMark;

(*  if EqualCheck.Checked then begin
    XScaleBar.Position:=XScaleBar.Max+1-YScaleBar.Position;
    ZScaleBar.Position:=YScaleBar.Position;
  end;*)
end;

procedure TMain.ZScaleBarChange(Sender: TObject);
var d:double;
begin
  d:=(ZScaleBar.Max+1-ZScaleBar.Position)/10;
  ZScalePanel.caption:=Float_Str(d,2);
  SetParsStr(FMarkStr,'sz',ZScalePanel.caption);
(*  if EqualCheck.Checked then begin
    XScaleBar.Position:=XScaleBar.Max+1-ZScaleBar.Position;
    YScaleBar.Position:=ZScaleBar.Position;
  end;*)
end;

procedure TMain.XRotBarChange(Sender: TObject);
var d: double;
begin
  d:=XRotBar.position;
  XRotPanel.caption:=Float_Str(d,0);
  SetParsStr(FMarkStr,'rx',XRotPanel.Caption);
end;

procedure TMain.YRotBarChange; {-------------------------------}
var d: double;
begin
  d := -YRotBar.position;
  YRotPanel.caption := Float_Str (d, 0);
  SetParsStr (FMarkStr, 'ry', YRotPanel.Caption);
end;

procedure TMain.ZRotBarChange; {-------------------------------}
var d: double;
begin
  d := -ZRotBar.position ;
  ZRotPanel.caption := Float_Str (d, 0);
  if AreaFlag <> '' then PaintMark;
  SetParsStr (FMarkStr, 'rz', ZRotPanel.Caption);
  if AreaFlag <> '' then PaintMark;
end;

procedure TMain.EditCloseButtonClick; {------------------------}
begin
  CloseEditState;
  ORegister.ActivePage := oselect;
end;

procedure TMain.ObjDelButtClick(Sender: TObject);
var x,y:integer;
begin
  if not iiOpen then exit;
  if FMarknum<0 then exit;
  x:=ParsInt(FMarkStr,'x',-1);
  y:=ParsInt(FMarkStr,'y',-1);
  if (x>=0) and (y>=0) then begin
    ResetMark;
    ORegister.ActivePage := oselect;
    DeleteObject(x, y, 1);
  end;
end;

procedure TMain.mmDeleteAllObjectsClick;
begin
  if not iiOpen then exit;
  if EditMode <> emObj then exit;
  CloseEditState;
  ORegister.ActivePage := oselect;
  OArr.Clear;
  OIdx:='';
  EArr_MMap;
  PaintFinishLine;
  PaintObjects;
  PaintClient;
  iiObjChanged := true;
end;

procedure TMain.mmDeleteAllBoundClick;
var i:integer;
begin
  if not iiOpen then exit;
  if EditMode <> emObj then exit;
  CloseEditState;
  ORegister.ActivePage := oselect;
  for i:=0 to OArr.Count-1 do begin
    if ParsStr(OArr[i],'name')='boundary' then OArr[i]:='Del';
  end;
  B_MakeOIdx;
  EArr_MMap;
  PaintFinishLine;
  PaintObjects;
  PaintClient;
  iiObjChanged := true;
end;

procedure TMain.mmDeleteAllHerrClick;
var i:integer;
begin
  if not iiOpen then exit;
  if EditMode <> emObj then exit;
  CloseEditState;
  ORegister.ActivePage := oselect;
  for i:=0 to OArr.Count-1 do begin
    if (ParsStr(OArr[i],'name')='herring') then OArr[i]:='Del';
  end;
  B_MakeOIdx;
  EArr_MMap;
  PaintFinishLine;
  PaintObjects;
  PaintClient;
  iiObjChanged := true;
end;

procedure TMain.mmDeleteAllFlagsClick;
var i:integer;
begin
  if not iiOpen then exit;
  if EditMode <> emObj then exit;
  CloseEditState;
  ORegister.ActivePage := oselect;
  for i:=0 to OArr.Count-1 do begin
    if (ParsStr(OArr[i],'name')='flag') then OArr[i]:='Del';
  end;
  B_MakeOIdx;
  EArr_MMap;
  PaintFinishLine;
  PaintObjects;
  PaintClient;
  iiObjChanged := true;
end;

procedure TMain.CloseButtonClick(Sender: TObject);
begin
  close;
end;



{--------------------------------------------------------------}
{                      mouse - loop                            }
{--------------------------------------------------------------}

procedure TMain.ClientMouseDown; {=============================}
var grey, idx: integer;
    isnew: boolean;
    r: TRect;
begin
  if not iiOpen then exit;
  if ButtonDown then exit;

  StartX := x div mpScale;
  StartY := y div mpScale;
  Oldx := StartX;
  Oldy := StartY;

  MinX := StartX;
  MaxX := StartX;
  MinY := StartY;
  MaxY := StartY;

  if EditMode = emElev then begin {.... Elevation ....}
    StoreElev;
    iiElevChanged := true;
    case mpElevTool of
      etBrush: PaintBrushSpot (StartX, StartY);
      etBlur:  PaintBlurSpot (StartX, StartY);
      etDark:  PaintBrightSpot (StartX, StartY);
      etMask:  PaintBrushSpot (StartX, StartY);
      etPip:   begin
               GreyScale.SetGrey(0);
               mpElevGrey := EArr[StartY,StartX];
               ForePanel.Color := cCol (mpElevGrey, mpElevGrey, mpElevGrey);
               end;
      etSpray: PaintSpraySpot (StartX, StartY);
    end;

  end else if EditMode = emTerr then begin {.... Terrain ....}
    StoreTerr;
    iiTerrChanged := true;
    PaintTerrSpot (StartX, StartY);

  end else if EditMode = emObj then begin {.... Object ....}
    iiObjChanged := true;
    case ObjectTool of
      otEdit: begin end;
      otAdd: begin
        idx := InsertObject (StartX, StartY, GetObjTyp, isnew);
        if idx >= 0 then begin
          if isnew then PaintObject (idx) else RegenerateObjectRect (StartX, StartY);
          PaintClient;
        end;
        end;
      otMulti: begin
        idx := InsertObject (StartX, StartY, GetObjTyp, isnew);
        if idx >= 0 then begin
          if isnew then PaintObject (idx) else RegenerateObjectRect (StartX, StartY);
          PaintClient;
        end;
        end;
      otDel: DeleteObject (StartX, StartY, 3);
      otDel2: DeleteObject (StartX, StartY, 5);
    end;
  end else if EditMode = emTarg then begin {.... Targets ....}
  end;

  ButtonDown := true;
end;

procedure TMain.ClientMouseMove; {=============================}
var diffx, diffy, grey, found: integer;
    i,xx,idx, yy:integer;
    hh,hhx: double;
    col: TColor;
begin
  if not iiOpen then exit;

  MoveX := x div mpScale;
  MoveY := y div mpScale;
  diffx := MoveX - OldX;
  diffy := MoveY - OldY;
  if (abs(diffx) < 1) and (abs(diffy) < 1) then exit;

  case EditMode of
    emElev: begin
      hh := B_ZPos2 (EArr [MoveY, MoveX], MoveY);
      hhx := B_ZGrey2 (hh, MoveY);
//      DisplayPanel.caption := ' Height:  ' + float_Str (hhx,2);
      if mpElevTool = etPip then begin
        if (x >= 0) and (x < MMap.Width) and (y >= 0) and (y < MMap.Height) then begin
          grey := EArr[y div mpScale, x div mpScale];
          if Assigned (Greyscale) then Greyscale.SetMark (grey);
        end;
      end;
      end;
    emTerr: begin
      if (x >= 0) and (x < MMap.Width) and (y >= 0) and (y < MMap.Height) then begin
        col := TMap.canvas.pixels [MoveX, MoveY];
        TerrPanel.caption := '  ' + TerrPalette.Col_TerrName (col);
      end;
      end;
    emObj: begin
      found:=ObjFindNear(MoveX, MoveY);
      if (found>=0) and (found<=OArr.Count-1) then begin
        ODispPanel.caption := ' '+ ParsStr(OArr[found],'trivname');
      end else ODispPanel.caption:='';
      end;
    emTarg: begin
      end;
  end;

  if MoveX < MinX then MinX := MoveX;
  if MoveX > MaxX then MaxX := MoveX;
  if MoveY < MinY then MinY := MoveY;
  if MoveY > MaxY then MaxY := MoveY;

  if not ButtonDown then exit;

  if EditMode = emElev then begin {.... Elevation ....}
    iiElevChanged := true;
    case mpElevTool of
      etBrush: PaintBrushTrack  (OldX, OldY, MoveX, MoveY, diffx, diffy);
      etBlur:  PaintBlurTrack   (OldX, OldY, MoveX, MoveY, diffx, diffy);
      etDark:  PaintBrightTrack (OldX, OldY, MoveX, MoveY, diffx, diffy);
      etMask:  PaintBrushTrack  (OldX, OldY, MoveX, MoveY, diffx, diffy);
      etSpray:  PaintSprayTrack  (OldX, OldY, MoveX, MoveY, diffx, diffy);
    end;

  end else if EditMode = emTerr then begin {.... Terrain ....}
    iiTerrChanged := true;
    PaintTerrTrack (OldX, OldY, MoveX, MoveY, diffx, diffy);

  end else if EditMode = emObj then begin {.... Object ....}
    case ObjectTool of
      otEdit: begin end;
      otAdd: begin end;
      otMulti: begin end;
      otDel: DeleteObject (MoveX, MoveY, 3);
      otDel2: DeleteObject (MoveX, MoveY, 5);
    end;

  end else if EditMode = emTarg then begin {.... Targets ....}
  end;

  OldX := MoveX;
  OldY := MoveY;
end;

procedure TMain.ClientMouseUp; {===============================}
var r: TRect;
    found, ax, ay: integer;
begin
  if not iiOpen then exit;
  if not ButtonDown then exit;

  if EditMode = emElev then begin
    if mpElevTool in [etSpray] then begin
      EArr_MMap;
    end else begin
      with r do begin
        left := MinX - mpBrushPar.size div 2;
        right := MaxX + mpBrushPar.size div 2 ;
        top := MinY - mpBrushPar.size div 2;
        bottom := MaxY + mpBrushPar.size div 2;
      end;
      EArrRect_MMap(r);
    end;

    PaintClient;
    if mpPaintLock then begin
      for ay := 0 to iiHeight-1 do
      for ax := 0 to iiWidth-1 do LockArr[ay,ax] := 0;
    end;
  end else if EditMode = emTerr then begin
      with r do begin
        left := MinX - mpTerrBrushSize div 2;
        right := MaxX + mpTerrBrushSize div 2 ;
        top := MinY - mpTerrBrushSize div 2;
        bottom := MaxY + mpTerrBrushSize div 2;
      end;
      TMapRect_MMap (r);
      PaintClient;
  end else if EditMode = emObj then begin
    case ObjectTool of
      otEdit: begin
        found := ObjFindNear (StartX, StartY);
        if found >= 0 then begin
          CloseEditState;
          OpenEditState (found);
          ORegister.ActivePage := oedit;
        end else begin //  no object found
          CloseEditState;
          ORegister.ActivePage := oselect;
        end;
        end;
      otAdd: SetObjectTool (otEdit);
      otMulti: begin end;
      otDel: begin end;
      otDel2: begin end;
    end;
  end else if EditMode = emTarg then begin
  end;

  ButtonDown := false;
end;

procedure TMain.AngleCheckClick(Sender: TObject);
begin
  if AngleCheck.Checked then begin
    SetParsInt (FMarkStr, 'ca', 1);
  end else begin
    SetParsInt (FMarkStr, 'ca', 0);
  end;
  ReadEditParams;
end;

procedure TMain.CommonListClick(Sender: TObject);
begin
  ShowObjDef;
end;

procedure TMain.SpeedButton7Click(Sender: TObject);
begin
  if AreaFlag<>'' then PaintMark;
  SetParsFloat (FMarkStr, 'sx', ParsFloat (FMarkStr, 'sz', 1), 4);
  SetParsFloat (FMarkStr, 'sy', ParsFloat (FMarkStr, 'sz', 1), 4);
  ReadEditParams;
  if AreaFlag<>'' then PaintMark;
end;

procedure TMain.BitBtn2Click(Sender: TObject);
begin
  RandomExecute;
end;

procedure TMain.BitBtn3Click(Sender: TObject);
begin
  RandomExecute;
end;

procedure TMain.Button1Click(Sender: TObject);
begin
  ShowElevBrush (BrushPaint.canvas, 4);
end;


procedure TMain.BasementBarChange(Sender: TObject);
begin
  mpBasementAngle := BasementBar.Position;
  BasementDisp.caption := IntToStr (mpBasementAngle) + ' ';
end;

procedure TMain.mmAboutClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMain.WithoutOutlineButtonClick(Sender: TObject);
begin
  iiShowOutlines := false;
  if EditMode = emObj then begin
    EArr_MMap;
    PaintFinishLine;
    PaintObjects;
    PaintClient;
  end;
end;

procedure TMain.OutlineButtonClick(Sender: TObject);
begin
  iiShowOutlines := true;
  if EditMode = emObj then begin
    EArr_MMap;
    PaintFinishLine;
    PaintObjects;
    PaintClient;
  end;
end;

procedure TMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var res: TModalResult;
begin
  if iiTerrChanged or iiObjChanged or iiElevChanged then begin
    SaveQueryForm.CancelButton.visible := true;
    res := SaveQueryForm.ShowModal;
    if res = mrYes then begin
      if iiElevChanged then iiObjChanged := true;
      F_SaveElev;
      F_SaveTerr;
      F_SaveObjects;
      CanClose := true;
    end else if res = mrNo then begin
      CanClose := true;
    end else if res = mrCancel then begin
      CanClose := false;
    end;
  end else CanClose := true;
end;

procedure TMain.Quit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMain.Randomlandscape1Click(Sender: TObject);
begin
  RandomExecute;
end;

procedure TMain.mmElevClearClick(Sender: TObject);
var y,x: integer;
begin
  if not iiOpen then exit;
  if EditMode <> emElev then exit;
  StoreElev;
  for x := 0 to iiWidth-1 do for y := 0 to iiHeight-1 do EArr[y,x] := mpElevGrey;
  EArr_MMap;
  PaintClient;
  iiElevChanged := true;
begin end;
end;

procedure TMain.mmSetColorsClick(Sender: TObject);
begin
  ColorSetForm.ShowModal;
end;

end.
