{--------------------------------------------------------------}
{                 button clicks                                }
{--------------------------------------------------------------}


procedure TMain.ScaleButt1Click(Sender: TObject);
begin
  SetScale (1);
end;

procedure TMain.ScaleButt2Click(Sender: TObject);
begin
  SetScale (2);
end;

procedure TMain.ScaleButt3Click(Sender: TObject);
begin
  SetScale (3);
end;

procedure TMain.ScaleButt4Click(Sender: TObject);
begin
  SetScale (4);
end;

procedure TMain.ScaleButt5Click(Sender: TObject);
begin
  SetScale (5);
end;

procedure TMain.ObjBrightButt1Click(Sender: TObject);
begin
  SetObjBright (1);
end;

procedure TMain.ObjBrightButt2Click(Sender: TObject);
begin
  SetObjBright (2);
end;

procedure TMain.ObjBrightButt3Click(Sender: TObject);
begin
  SetObjBright (3);
end;

procedure TMain.ObjBrightButt4Click(Sender: TObject);
begin
  SetObjBright (4);
end;

procedure TMain.ObjBrightButt5Click(Sender: TObject);
begin
  SetObjBright (5);
end;

procedure TMain.BrushButtClick(Sender: TObject);
begin
  SetElevTool (etBrush);
end;

procedure TMain.DarkButtClick(Sender: TObject);
begin
  SetElevTool (etDark);
end;

procedure TMain.BlurButtClick(Sender: TObject);
begin
  SetElevTool (etBlur);
end;

procedure TMain.PipetteButtClick(Sender: TObject);
begin
  SetElevTool (etPip);
end;

procedure TMain.MaskButtClick(Sender: TObject);
begin
  SetElevTool (etMask);
end;

procedure TMain.CourseButtonClick(Sender: TObject);
begin
  SetEditMode (emCourse);
end;

procedure TMain.ElevationButtonClick(Sender: TObject);
begin
  SetEditMode (emElev);
end;

procedure TMain.TerrainButtonClick(Sender: TObject);
begin
  SetEditMode (emTerr);
end;

procedure TMain.ObjectsButtonClick(Sender: TObject);
begin
  SetEditMode (emObj);
end;

procedure TMain.TargetsButtonClick(Sender: TObject);
begin
  SetEditMode (emTarg);
end;

procedure TMain.InternalButtonClick(Sender: TObject);
begin
  SetEditMode (emIntern);
end;

procedure TMain.ElevBrushSelect(nr: Integer);
begin
  SetElevBrush (nr);
end;

procedure TMain.SaveFileButtonClick(Sender: TObject);
begin
  SaveCourse;
end;

procedure TMain.mmSaveClick(Sender: TObject);
begin
  SaveCourse;
end;

procedure TMain.OEditButtonClick(Sender: TObject);
begin
  SetObjectTool (otEdit);
end;

procedure TMain.OAddButtonClick(Sender: TObject);
begin
  SetObjectTool (otAdd);
end;

procedure TMain.ODelButtonClick(Sender: TObject);
begin
  SetObjectTool (otDel);
end;

procedure TMain.OMultiButtonClick(Sender: TObject);
begin
  SetObjectTool (otMulti);
end;

procedure TMain.MoveUpButtonMouseDown;
begin
  MoveObject (0, -MoveStep.Position);
end;

procedure TMain.MoveLeftButtonMouseDown;
begin
  MoveObject (-MoveStep.Position, 0);
end;

procedure TMain.MoveRightButtonMouseDown;
begin
  MoveObject (MoveStep.Position, 0);
end;

procedure TMain.MoveDownButtonMouseDown;
begin
  MoveObject (0, MoveStep.Position);
end;

procedure TMain.ODelButton2Click(Sender: TObject);
begin
  SetObjectTool (otDel2);
end;

procedure TMain.ClientScrollMouseMove; {-----------------------}
begin
  ODispPanel.caption := '';
  TerrPanel.caption := '';
  GreyScale.ResetMark;
end;

procedure TMain.CommonButtonClick(Sender: TObject);
begin
  ObjectRegister.ActivePage := common;
  ShowObjDef;
end;

procedure TMain.TreesButtonClick(Sender: TObject);
begin
  ObjectRegister.ActivePage := trees;
  ShowObjDef;
end;

procedure TMain.RocksButtonClick(Sender: TObject);
begin
  ObjectRegister.ActivePage := rocks;
  ShowObjDef;
end;

procedure TMain.HousesButtonClick(Sender: TObject);
begin
  ObjectRegister.ActivePage := houses;
  ShowObjDef;
end;

procedure TMain.BridgesButtonClick(Sender: TObject);
begin
  ObjectRegister.ActivePage := bridges;
  ShowObjDef;
end;

procedure TMain.MiscButtonClick(Sender: TObject);
begin
  ObjectRegister.ActivePage := misc;
  ShowObjDef;
end;

procedure TMain.mmOpenClick(Sender: TObject);
begin
  OpenCourse;
end;

procedure TMain.OpenFileButtonClick(Sender: TObject);
begin
  OpenCourse;
end;

procedure TMain.mmCloseClick;
begin
  CloseCourse;
end;

procedure TMain.ClientRegisterChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := false;
end;

procedure TMain.ORegisterChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := false;
end;

procedure TMain.ObjectRegisterChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := false;
end;

procedure TMain.ObjVisButtonClick(Sender: TObject);
begin
  TMap_MMap;
  PaintFinishLine;
  PaintObjects;
  PaintClient;
end;

procedure TMain.ObjUnvisibButtonClick(Sender: TObject);
begin
  TMap_MMap;
  PaintClient;
end;

procedure TMain.ObjVisButton2Click(Sender: TObject);
begin
  EArr_MMap;
  PaintFinishLine;
  PaintObjects;
  PaintClient;
end;

procedure TMain.ObjUnvisButton2Click(Sender: TObject);
begin
  EArr_MMap;
  PaintClient;
end;

procedure TMain.ScriptButtonClick(Sender: TObject);
begin
  SetEditMode (emScript);
end;

procedure TMain.SpeedButton10Click(Sender: TObject);
begin
  SetElevTool (etSpray);
end;

procedure TMain.MinSprayBarChange(Sender: TObject);
begin
  mpMinSpray := MinSprayBar.Position;
  if MaxSprayBar.Position < MinSprayBar.Position then MaxSprayBar.Position := MinSprayBar.Position;
  MinSprayDisp.Caption := IntToStr (MinSprayBar.Position);
end;

procedure TMain.MaxSprayBarChange(Sender: TObject);
begin
  mpMaxSpray := MaxSprayBar.Position;
  if MinSprayBar.Position > MaxSprayBar.Position then MinSprayBar.Position := MaxSprayBar.Position;
  MaxSprayDisp.Caption := IntToStr (MaxSprayBar.Position);
end;

procedure TMain.VallBarChange(Sender: TObject);
begin
  mpVall := VallBar.Position;
  if MountBar.Position < VallBar.Position then MountBar.Position := VallBar.Position;
  VallDisp.caption := IntToStr (VallBar.Position);
end;

procedure TMain.MountBarChange(Sender: TObject);
begin
  mpMount := MountBar.Position;
  if VallBar.Position > MountBar.Position then VallBar.Position := MountBar.Position;
  MountDisp.caption := IntToStr (MountBar.Position);
end;

procedure TMain.SpecialButton1Click(Sender: TObject);
begin
  MaskExecute (1);
end;

procedure TMain.SpecialButton2Click(Sender: TObject);
begin
  MaskExecute (2);
end;

procedure TMain.SpecialButton3Click(Sender: TObject);
begin
  MaskExecute (3);
end;

procedure TMain.ForePanelClick(Sender: TObject);
var zwi: integer;
begin
  zwi := mpElevGrey;
  mpElevGrey := mpBackGrey;
  mpBackGrey := zwi;
  ForePanel.Color := cCol (mpElevGrey, mpElevGrey, mpElevGrey);
  BackPanel.Color := cCol (mpBackGrey, mpBackGrey, mpBackGrey);
end;

procedure TMain.UndoButtonClick(Sender: TObject);
begin
  Undo;
end;

procedure TMain.BlurBarChange(Sender: TObject);
begin
  mpBlur := BlurBar.Position;
  BlurDisp.Caption := IntToStr (BlurBar.Position);
end;

procedure TMain.BrightBarChange(Sender: TObject);
begin
  mpBright := BrightBar.Position;
  GenerateBrightBrush;
  BrightDisp.Caption := IntToStr (BrightBar.Position);
end;

procedure TMain.MixBarChange(Sender: TObject);
begin
  SetMix (MixBar.Position);
end;


procedure TMain.MaskPaintButtonClick(Sender: TObject);
begin
  SetMaskMode (1);
end;

procedure TMain.MaskUnpaintButtonClick(Sender: TObject);
begin
  SetMaskMode (2);
end;

procedure TMain.MaskClearButtonClick(Sender: TObject);
begin
  ClearMask;
end;

procedure TMain.ObjectRegisterChange(Sender: TObject);
begin
  ShowObjDef;
end;

procedure TMain.MinSizeBarChange(Sender: TObject);
begin
  if MinSizeBar.position > MaxSizeBar.position then MaxSizeBar.position := MinSizeBar.position;
  ShowRandomSize;
end;

procedure TMain.MaxSizeBarChange(Sender: TObject);
begin
  if MinSizeBar.position > MaxSizeBar.position then MinSizeBar.position := MaxSizeBar.position;
  ShowRandomSize;
end;

procedure TMain.MinRotBarChange(Sender: TObject);
begin
  if MinRotBar.position > MaxRotBar.position then MaxRotBar.position := MinRotBar.position;
  ShowRandomRot;
end;

procedure TMain.MaxRotBarChange(Sender: TObject);
begin
  if MinRotBar.position > MaxRotBar.position then MinRotBar.position := MaxRotBar.position;
  ShowRandomRot;
end;




