program PTuxedit;

uses
  QForms,
  FTuxedit in 'FTuxedit.pas' {Main},
  FCourseDir in 'FCourseDir.pas' {CourseDirForm},
  UTuxbase in 'UTuxbase.pas',
  UFiles in 'UFiles.pas',
  FCourseParams in 'FCourseParams.pas' {CourseParamsForm},
  QGrey in 'QGrey.pas',
  QElevBrush in 'QElevBrush.pas',
  QTerrPalette in 'QTerrPalette.pas',
  UMaps in 'UMaps.pas',
  QTerrBrush in 'QTerrBrush.pas',
  UObjects in 'UObjects.pas',
  USpecial in 'USpecial.pas',
  FAbout in 'FAbout.pas' {AboutForm},
  FSaveQuery in 'FSaveQuery.pas' {SaveQueryForm},
  FColorSet in 'FColorSet.pas' {ColorSetForm},
  UStandard in 'UStandard.pas';

{$R *.res}

begin
  Application.Initialize;
  Application.CreateForm(TMain, Main);
  Application.CreateForm(TCourseDirForm, CourseDirForm);
  Application.CreateForm(TCourseParamsForm, CourseParamsForm);
  Application.CreateForm(TAboutForm, AboutForm);
  Application.CreateForm(TSaveQueryForm, SaveQueryForm);
  Application.CreateForm(TColorSetForm, ColorSetForm);
  Application.Run;
end.
